/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.filters.jcr;

import java.io.IOException;
import java.util.*;

import javax.jcr.*;
import javax.naming.*;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.exoplatform.services.jcr.rmi.*;
import org.exoplatform.container.client.http.HttpClientInfo;
import org.exoplatform.container.StandaloneContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.UserProfile;


/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:lautarul@gmail.com">Roman Pedchenko</a>
 * @version $Id: Helper.java 4326 2006-02-26 08:27:29Z geaz $
 */

public class Helper {

  public static Repository requestRepository(HttpServletRequest httpRequest, String s, boolean useRmi) throws Exception {
    Repository repository = null;
    if (s == null)
      repository = (Repository) httpRequest.getSession().getAttribute("repo");
    if (repository == null) {
      if (useRmi) {
        RepositoryFactory factory = new RepositoryFactory();
        repository = factory.getRepository(s);
      } else {
        InitialContext ctx = new InitialContext();
        try {
          repository = (Repository) ctx.lookup(s);
        } catch (NamingException e) {
          repository = (Repository) ctx.lookup("java:comp/env/jcr/" + s);
        }
      }
    }
    httpRequest.getSession().setAttribute("repo", repository);
System.out.println("  -- repository: " + repository);
    return repository;
  }

	static public void removeAttributes(HttpSession session) {
		Enumeration e = session.getAttributeNames();
		while(e.hasMoreElements()) {
			String key = (String) e.nextElement();
			session.removeAttribute(key);
		}
	}

  private static void newSessionContainer(HttpServletRequest request_) throws Exception {
    StandaloneContainer container_ = StandaloneContainer.getInstance();
    HttpSession session = request_.getSession();
//    removeAttributes(session);
    container_.removeSessionContainer(session.getId());
    SessionContainer scontainer_ = container_.createSessionContainer(session.getId());
    scontainer_.setClientInfo(new HttpClientInfo(request_)) ;
    scontainer_.setUniqueId(session.getId()) ;
    OrganizationService orgService = 
      (OrganizationService) container_.getComponentInstanceOfType(OrganizationService.class);
    UserProfile userProfile = 
      orgService.getUserProfileHandler().findUserProfileByName(scontainer_.getOwner());
    if (userProfile == null) { 
      userProfile = orgService.getUserProfileHandler().createUserProfileInstance();
    }
    scontainer_.registerComponentInstance(UserProfile.class, userProfile);
  }

  public static void tuneRequest(HttpServletRequest request_) {
    try {
      newSessionContainer(request_);
    } catch (Exception e) {}
  }

}
