/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.storage;

import java.util.Calendar;

import javax.jcr.RepositoryException;

/**
 * Created by The eXo Platform SARL .<br>
 * 
 * Serves repository workspace persistent storage.
 * Acts as factory for WorkspaceStorageConnection objects, the implementation should support thread safety for openConnection() method;  
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: WorkspaceDataContainer.java 5150 2006-04-17 06:44:21Z geaz $
 */

public interface WorkspaceDataContainer {
 
  /**
   * @return some info about this container
   */
  String getInfo();
  
  /**
   * @return name of this container (see container configuration)
   */
  String getName();

  /**
   * [G.A] do we need it here or in WorkspaceDataManager better??
   * @return current time as for this container env
   */
  Calendar getCurrentTime();
  
  /**
   * @return the new connection to workspace storage
   * normally implementation of this method should be synchronized
   */
  WorkspaceStorageConnection openConnection() throws RepositoryException ;

}