/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core;

import java.util.Collection;

import javax.jcr.RepositoryException;
import javax.transaction.RollbackException;
import javax.transaction.SystemException;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.jcr.config.WorkspaceEntry;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.transaction.TransactionService;

/**
 * Created by The eXo Platform SARL        .
 * 
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: SessionFactory.java 6197 2006-06-15 06:38:01Z geaz $
 */

public class SessionFactory {

	private OrganizationService organizationService;
  private ExoContainer container;
  //private XAGlobalRegistry xaRegistry;
  private TransactionService tService;
  private String workspaceName;
	
	public SessionFactory(OrganizationService orgService, 
      TransactionService tService, WorkspaceEntry config, ExoContainerContext containerContext) {
		this.organizationService = orgService;
    this.container = containerContext.getContainer();
    //this.xaRegistry = xaRegistry;
    this.workspaceName = config.getName();
    this.tService = tService;
	}
  
  
	XASessionImpl createSession(CredentialsImpl credentials) 
	    throws RepositoryException {
		
		Collection groups;
		try {
			groups = organizationService.getGroupHandler().findGroupsOfUser(credentials.getUserID());
		} catch (Exception e) {
			throw new RepositoryException("AccessManager failed " + e);
		}
		// Check privilegies to access workspace first?
		//AccessManager accessManager = new AccessManager(credentials.getUserID(), groups);
		//return null;
    //return new SessionImpl(workspaceName, credentials, container);
    XASessionImpl sess = new XASessionImpl(workspaceName, credentials, container, tService);
    try {
      tService.enlistResource(sess);
    } catch (RollbackException e) {
      throw new RepositoryException(e);
    } catch (SystemException e) {
      throw new RepositoryException(e);
    }
    return sess;
 
	}

}
