/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core.nodetype;

import java.util.List;

import javax.jcr.NamespaceRegistry;
import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.UnsupportedRepositoryOperationException;
import javax.jcr.nodetype.NoSuchNodeTypeException;
import javax.jcr.nodetype.NodeType;

import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.impl.core.SessionImpl;
import org.exoplatform.services.jcr.impl.core.value.ValueFactoryImpl;
import org.exoplatform.services.jcr.impl.dataflow.DataManager;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: WorkspaceNTManagerImpl.java 6274 2006-06-19 09:08:42Z geaz $
 */

class WorkspaceNTManagerImpl extends NodeTypeManagerImpl {

  private SessionImpl session;
  
  WorkspaceNTManagerImpl(
      //DataManager dataManager, 
      NamespaceRegistry namespaceRegistry, 
      String accessControlPolicy, 
      SessionImpl session, 
      
      List <NodeType>  nodeTypes) throws RepositoryException {
    super(
        //dataManager, 
        session.getLocationFactory(), (ValueFactoryImpl) session.getValueFactory(), 
        namespaceRegistry, 
        accessControlPolicy,
        null,
        nodeTypes);
    log = ExoLogger.getLogger("jcr.WorkspaceNTManagerImpl");
    this.session = session;
  }

  public SessionImpl getSession() {
    return session;
  }

  public NodeType getNodeType(InternalQName qName) throws NoSuchNodeTypeException, RepositoryException {
    
    NodeTypeImpl nt = (NodeTypeImpl)super.getNodeType(qName);
    return new WorkspaceNTImpl(nt, session); 
  }
  
  public synchronized void initStorage(Node sysNode, boolean forcePersistence)
    throws RepositoryException {
    throw new UnsupportedRepositoryOperationException("Method is not accessible from this class");
  }
  
}
