/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.jcr.impl.storage.rdb.container.data;

import org.exoplatform.services.jcr.datamodel.IllegalPathException;
import org.exoplatform.services.jcr.datamodel.InternalQPath;
import org.exoplatform.services.jcr.datamodel.ItemData;

/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: MultiRDBItemRecord.java 5330 2006-04-28 16:00:52Z peterit $
 * 
 * @hibernate.class table="JCR_MITEM" l--azy="true"
 * @hibe---rnate.cache usage="read-write"
 * 
 */

public abstract class MultiRDBItemRecord implements ItemRecord {

  protected String id;
  protected String path;
  protected int version;
  protected NodeRecord parentNode;
  protected String parentUUID;

  public MultiRDBItemRecord() {
  }

  private void toLog(String message) {
    System.err.println(message);
  }
  
  /**
   * @hibernate.id generator-class="assigned" column="ID"
   */
  public String  getId() {
    //toLog("==== getId(): " + path + "  " + version + "  " + id);
    return id;
  }

  public void  setId(String id) {
    this.id = id;
  }

  /**
   * @hibernate.property co--lumn="PATH" n--ot-null="true" un--ique="true"
   * @hibernate.column name="PATH" length="1024" index="JCR_IDX_ITEM_PATH" not-null="true" 
   */
   public String getPath() {
     //toLog("==== getPath(): " + path);
     return path;
   }

   public void setPath(String path) {
     this.path = path;
   }

   /**
    * @h--ibernate.version column="VERSION"
    * @h--ibernate.column name="VERSION" not-null="true"
    * @hibernate.property column="VERSION"
    */
    public int getPersistedVersion() {
      //toLog("==== getPersistedVersion(): " + version);
      return version;
    }
   
	public void setPersistedVersion(int version) {
		this.version = version;
	}

  // ----------- ItemData --------------
  public InternalQPath getQPath() {
     try {
     	 return InternalQPath.parse(path);
     } catch (IllegalPathException e) {
       e.printStackTrace();
       throw new RuntimeException(e);
     }
  }
    
 	public String getParentUUID() {
 	  //toLog("==== getParentUUID(): " + path + "  " + version + "  parentUUID:" + parentUUID);
		return parentUUID;
	}
 	
	public String getUUID() {
		return id;
	}
 
     // ---------------------------------
	
	
	public boolean equals(Object other) {
		if (this == other)
			return true;
		if (!(other instanceof MultiRDBItemRecord))
			return false;
		return this.getId() == ((MultiRDBItemRecord) other).getId();
	}

	public int hashCode() {
		return getId().hashCode();
	}
 
}
