/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
 
package org.exoplatform.services.jcr.impl.storage.rdb.container.data;


/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: MultiRDBValueRecord.java 5330 2006-04-28 16:00:52Z peterit $
 * 
 * @hibernate.class table="JCR_MVALUE" l--azy="true"
 */
public class MultiRDBValueRecord implements ValueRecord {

	private Long id;

  private byte[] data;

  private PropertyRecord property;

  private int orderNum;

  public MultiRDBValueRecord() {
  }

  /** @hibernate.id generator-class="increment" column="ID" */
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  /**
   * @hibernate.property column="DATA" length="65535" type="binary"
   *                     not-null="true"
   */
  public byte[] getData() {
    return data;
  }

  public void setData(byte[] data) {
    this.data = data;
  }

  /**
   * @hibernate.property column="ORDER_NUM"
   */
  public int getOrderNumber() {
    return orderNum;
  }

  public void setOrderNumber(int orderNum) {
    this.orderNum = orderNum;
  }

  /**
   * @hibernate.many-to-one column="PROPERTY_ID" not-null="true"
   *                        class="org.exoplatform.services.jcr.impl.storage.rdb.container.data.MultiRDBPropertyRecord"
   *                        foreign-key="JCR_FK_VALUE_PROPERTY"
   *  
   */
  public PropertyRecord getProperty() {
    return property;
  }

  public void setProperty(PropertyRecord property) {
    this.property = property;
  }

  // ------------------ ValueData --------------------------

  public byte[] getAsByteArray() {
    return getData();
  }

  // ------------------------------------------------------

}