/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.storage.rdb.container.data;

import org.exoplatform.services.jcr.datamodel.IllegalPathException;
import org.exoplatform.services.jcr.datamodel.InternalQPath;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: SingleRDBItemRecord.java 5307 2006-04-27 13:55:57Z peterit $
 * 
 * @hibernate.class table="JCR_SITEM"
 * 
 */

public abstract class SingleRDBItemRecord implements ItemRecord {
  
  protected String id;

  protected String path;

  protected int version;

  protected NodeRecord parentNode;

  protected String containerName;
  
  protected String parentUUID;

  public SingleRDBItemRecord() {
    super();
  }

  /**
   * @hibernate.id generator-class="assigned" column="ID"
   */
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }
  
  /**
   * @hibernate.property column="CONTAINER_NAME"
   */
  public String getContainerName() {
    return containerName;
  }

  public void setContainerName(String containerName) {
    this.containerName = containerName;
  }

  /**
   * @hibernate.property co--lumn="PATH" n--ot-null="true" un--ique="true"
   * @hibernate.column name="PATH" in--dex="PATH_IDX" not-null="true" 
   */
  public String getPath() {
    return path;
  }

  public void setPath(String path) {
    this.path = path;
  }

  /**
   * @h---ibernate.version column="VERSION"
   * @hibernate.column name="PVERSION" not-null="true"
   */
  public int getPersistedVersion() {
    return version;
  }

  public void setPersistedVersion(int version) {
    this.version = version;
  }

  // ----------- ItemData --------------
  public InternalQPath getQPath() {
    try {
      return InternalQPath.parse(path);
    } catch (IllegalPathException e) {
      e.printStackTrace();
      throw new RuntimeException(e);
    }
  }

  public String getParentUUID() {
    return parentUUID;
  }

  public String getUUID() {
    return id.substring(containerName.length(), id.length());
  }

  // ---------------------------------

  public boolean equals(Object other) {
    if (this == other)
      return true;
    if (!(other instanceof SingleRDBItemRecord))
      return false;
    return this.getId() == ((SingleRDBItemRecord) other).getId();
  }

  public int hashCode() {
    return getId().hashCode();
  }

}
