/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.storage.value.fs;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.storage.value.ValueIOChannel;
import org.exoplatform.services.jcr.storage.value.ValuePluginFilter;
import org.exoplatform.services.jcr.storage.value.ValueStoragePlugin;
import org.exoplatform.services.log.ExoLogger;
/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: $
 */

public class SimpleFileValueStorage implements ValueStoragePlugin {
  
  protected static Log log = ExoLogger.getLogger("jcr.SimpleFileValueStorage");

  public final static String PATH = "path";

  private File rootDir;
  private List <ValuePluginFilter> filters;
  
  public SimpleFileValueStorage() {
  }
  
  public void init(Properties props, List <ValuePluginFilter> filters) throws IOException {
    log.info(">>>>>>>>>>>>>>>>>>>>>>>>>>>>> ");

    String rootDirPath = props.getProperty(PATH);
    this.rootDir = new File(rootDirPath);
    if(!rootDir.exists()) {
      rootDir.mkdir();
      log.info("Directory created: "+rootDir.getAbsolutePath());
    } else {
      if(!rootDir.isDirectory())
        throw new IOException("File exists but is not a directory "+rootDirPath);
    }
    this.filters = filters;
  }

  public ValueIOChannel openIOChannel() throws IOException {
    return new FileIOChannel(rootDir);
  }

  public List <ValuePluginFilter> getFilters() {
    return filters;
  }

}
