/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/

package org.exoplatform.services.jcr.impl.load;

import java.lang.management.ManagementFactory;
import java.lang.management.MemoryMXBean;

import javax.jcr.Node;

import org.apache.commons.logging.Log;
import org.exoplatform.services.jcr.BaseStandaloneTest;
import org.exoplatform.services.log.ExoLogger;


/**
 * Created by The eXo Platform SARL        .
 *
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov</a>
 * @version $Id: LoadTest.java 5150 2006-04-17 06:44:21Z geaz $
 */

public class LoadTest extends BaseStandaloneTest {
  
  private Log log = ExoLogger.getLogger("jcr.Test");

  private MemoryMXBean memxbin; 

  protected String getRepositoryName() {
    return "db1";
  }
  
  public void testLoad() throws Exception {
    
    memxbin = ManagementFactory.getMemoryMXBean();

    
    
    int cnt = 30;
    
    long start = System.currentTimeMillis();
    int count = 0;
    for(int i=0; i<cnt; i++) {
      Node subRoot = root.addNode("node"+i,"nt:unstructured");
        for(int i2=0; i2<cnt; i2++) {
          Node node = subRoot.addNode("node"+i2,"nt:unstructured");
          node.addMixin("mix:versionable");
          count++;
        }
      session.save();
      System.out.println("Create time "+(System.currentTimeMillis()-start)+
          " Added nodes = "+count);
      System.out.println("Java memory in use = " + 
          Runtime.getRuntime().totalMemory() + " "+ Runtime.getRuntime().freeMemory());

      //log.info(" MEM usage:  heap.getUsed "+
      //    memxbin.getHeapMemoryUsage().getUsed()+"\n"+
      //    );
    }
    
    //log.info("Create time "+(System.currentTimeMillis()-start)+" Added nodes = "+count);
  }
  
/*
  public void testStressLoad() throws Exception {

//    logService.setLogLevel("org.exoplatform.services.jcr", LogService.INFO, true);
  	
  	int cnt = 10;
	
  	long start = System.currentTimeMillis();
  	for(int i=0; i<cnt; i++) {
  		Node subRoot = root.addNode("node"+i,"nt:unstructured");
  	  	for(int i2=0; i2<cnt; i2++) {
  	  		subRoot.addNode("node"+i2,"nt:unstructured");
  	  	}
  	}
  	log.info("Create time "+(System.currentTimeMillis()-start));

  	start = System.currentTimeMillis();
  	for(int i=0; i<cnt; i++) {
//  		Node subRoot = root.addNode("node"+i,"nt:unstructured");
  	  	for(int i2=0; i2<cnt; i2++) {
  	  		root.getNode("node"+i+"/node"+i2);
  	  	}
  	}
  	log.info("read (from transient storage) time "+(System.currentTimeMillis()-start));
  	
  	start = System.currentTimeMillis();
  	session.save();
  	log.info("Save time "+(System.currentTimeMillis()-start));
  	
  	start = System.currentTimeMillis();
  	for(int i=0; i<cnt; i++) {
   	  	for(int i2=0; i2<cnt; i2++) {
  	  		root.getNode("node"+i+"/node"+i2);
  	  	}
  	}
  	log.info("read time "+(System.currentTimeMillis()-start));
  	
  	start = System.currentTimeMillis();
  	for(int i=cnt-1; i>=0; i--) {
//  		Node subRoot = root.addNode("node"+i,"nt:unstructured");

  	  	for(int i2=0; i2<cnt; i2++) {
  	  		root.getNode("node"+i+"/node"+i2);
  	  	}
  	}
  	log.info("next read time (probably w/ cache) "+(System.currentTimeMillis()-start));
  	
  }
*/  
 /* 
  public void testLoadFromSystemNode() throws Exception {
  	NodeTypeManagerImpl ntManager = (NodeTypeManagerImpl)session.getWorkspace().getNodeTypeManager();
  	Node sys = (Node)repository.getSystemSession().getItem("/jcr:system");
  	ntManager.initStorage(sys, true);

  	SessionImpl ses = (SessionImpl)repository.login(credentials, WORKSPACE); 
  	ses.getTransientNodesManager().getWorkspaceDataManager().getCache().clear();
  	log.info("start read time ");
  	long  start = System.currentTimeMillis();
  	Node ntRoot = (Node)ses.getItem(NodeTypeManagerImpl.NT_ROOT);
  	TraversingItemVisitor.Default v = new TraversingItemVisitor.Default();
  	ntRoot.accept(v);
//  	assertTrue(ntRoot.hasNodes());
//  	NodeIterator nodes = ntRoot.getNodes();
  	
//  	while(nodes.hasNext()) {
//  	    log.debug(">> "+nodes.nextNode().getPath());
//  	}
  	
  	log.info("read time "+(System.currentTimeMillis()-start));

  	start = System.currentTimeMillis();
  	v = new TraversingItemVisitor.Default();
  	SessionImpl ses2 = (SessionImpl)repository.login(credentials, WORKSPACE); 
  	ntRoot = (Node)ses2.getItem(NodeTypeManagerImpl.NT_ROOT);
  	ntRoot.accept(v);

  	//assertTrue(ntRoot.hasNodes());
  	//nodes = ntRoot.getNodes();
  	//while(nodes.hasNext()) {
  	//    log.debug(">> "+nodes.nextNode().getPath());
  	//}
  	log.info("next read time "+(System.currentTimeMillis()-start));

  }
  */
  
}
